#include "mcc_generated_files/mcc.h"
uint16_t TIME;

/*
 * 点灯時間[usec]
 * 0 90
 * 1 110
 * 2 150
 * 3 229
 * 4 388
 * 5 706
 * 6 1342
 * 7 2612
 */
void X_Handler(){
    __delay_us(39);     // GPIOの操作時間、loopの操作時間があるため、これで90usecとなる。
    for(uint16_t i=0; i<TIME; i++)
        __delay_us(18);
    Quench_SetHigh();
    __delay_ms(20);
    Quench_SetLow();
}
/*
                         Main application
 */
void main(void)
{
    SYSTEM_Initialize();
    // フラッシュ入力はフラッシュ側で5VにPullupされている。
    // Low Pulse入力で割込みを掛ける。
    IOCAF4_SetInterruptHandler(X_Handler);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();

    while (1)
    {
        // 発光時間設定
        // 4bit Dip switchで入力。2^Nの値を設定しておく
        TIME = 1<<(~PORTA & 0xf);
        SLEEP();    //通常はSLEEPさせておき、WDTで1秒おきに設定を読み込む
    }
}
/**
 End of File
*/