/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F18313
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.36 and above
        MPLAB 	          :  MPLAB X 6.00	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set T0 aliases
#define T0_TRIS                 TRISAbits.TRISA0
#define T0_LAT                  LATAbits.LATA0
#define T0_PORT                 PORTAbits.RA0
#define T0_WPU                  WPUAbits.WPUA0
#define T0_OD                   ODCONAbits.ODCA0
#define T0_ANS                  ANSELAbits.ANSA0
#define T0_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define T0_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define T0_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define T0_GetValue()           PORTAbits.RA0
#define T0_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define T0_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define T0_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define T0_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define T0_SetPushPull()        do { ODCONAbits.ODCA0 = 0; } while(0)
#define T0_SetOpenDrain()       do { ODCONAbits.ODCA0 = 1; } while(0)
#define T0_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define T0_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set T1 aliases
#define T1_TRIS                 TRISAbits.TRISA1
#define T1_LAT                  LATAbits.LATA1
#define T1_PORT                 PORTAbits.RA1
#define T1_WPU                  WPUAbits.WPUA1
#define T1_OD                   ODCONAbits.ODCA1
#define T1_ANS                  ANSELAbits.ANSA1
#define T1_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define T1_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define T1_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define T1_GetValue()           PORTAbits.RA1
#define T1_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define T1_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define T1_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define T1_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define T1_SetPushPull()        do { ODCONAbits.ODCA1 = 0; } while(0)
#define T1_SetOpenDrain()       do { ODCONAbits.ODCA1 = 1; } while(0)
#define T1_SetAnalogMode()      do { ANSELAbits.ANSA1 = 1; } while(0)
#define T1_SetDigitalMode()     do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set T2 aliases
#define T2_TRIS                 TRISAbits.TRISA2
#define T2_LAT                  LATAbits.LATA2
#define T2_PORT                 PORTAbits.RA2
#define T2_WPU                  WPUAbits.WPUA2
#define T2_OD                   ODCONAbits.ODCA2
#define T2_ANS                  ANSELAbits.ANSA2
#define T2_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define T2_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define T2_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define T2_GetValue()           PORTAbits.RA2
#define T2_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define T2_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define T2_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define T2_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define T2_SetPushPull()        do { ODCONAbits.ODCA2 = 0; } while(0)
#define T2_SetOpenDrain()       do { ODCONAbits.ODCA2 = 1; } while(0)
#define T2_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define T2_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set T3 aliases
#define T3_PORT                 PORTAbits.RA3
#define T3_WPU                  WPUAbits.WPUA3
#define T3_GetValue()           PORTAbits.RA3
#define T3_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define T3_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)

// get/set X aliases
#define X_TRIS                 TRISAbits.TRISA4
#define X_LAT                  LATAbits.LATA4
#define X_PORT                 PORTAbits.RA4
#define X_WPU                  WPUAbits.WPUA4
#define X_OD                   ODCONAbits.ODCA4
#define X_ANS                  ANSELAbits.ANSA4
#define X_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define X_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define X_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define X_GetValue()           PORTAbits.RA4
#define X_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define X_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define X_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define X_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define X_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define X_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define X_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define X_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set Quench aliases
#define Quench_TRIS                 TRISAbits.TRISA5
#define Quench_LAT                  LATAbits.LATA5
#define Quench_PORT                 PORTAbits.RA5
#define Quench_WPU                  WPUAbits.WPUA5
#define Quench_OD                   ODCONAbits.ODCA5
#define Quench_ANS                  ANSELAbits.ANSA5
#define Quench_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define Quench_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define Quench_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define Quench_GetValue()           PORTAbits.RA5
#define Quench_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define Quench_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define Quench_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define Quench_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define Quench_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define Quench_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define Quench_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define Quench_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCAF4 pin functionality
 * @Example
    IOCAF4_ISR();
 */
void IOCAF4_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCAF4 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCAF4 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF4_SetInterruptHandler(MyInterruptHandler);

*/
void IOCAF4_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCAF4 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCAF4_SetInterruptHandler() method.
    This handler is called every time the IOCAF4 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF4_SetInterruptHandler(IOCAF4_InterruptHandler);

*/
extern void (*IOCAF4_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCAF4 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCAF4_SetInterruptHandler() method.
    This handler is called every time the IOCAF4 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF4_SetInterruptHandler(IOCAF4_DefaultInterruptHandler);

*/
void IOCAF4_DefaultInterruptHandler(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/